=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-01-21 17:23:10 +0000
+++ branchview/treeview.py	2008-01-21 17:32:13 +0000
@@ -74,7 +74,10 @@
                              ()),
         'revision-selected': (gobject.SIGNAL_RUN_FIRST,
                               gobject.TYPE_NONE,
-                              ())
+                              ()),
+        'tag-added': (gobject.SIGNAL_RUN_FIRST,
+                              gobject.TYPE_NONE,
+                              (gobject.TYPE_STRING, gobject.TYPE_STRING))
     }
 
     def __init__(self, branch, start, maxnum, compact=True):
@@ -183,6 +186,8 @@
 
         finally:
             self.branch.lock_read()
+
+        self.emit('tag-added', tag, revid)
         
     def refresh(self):
         gobject.idle_add(self.populate, self.get_revision())

=== modified file 'revisionview.py'
--- revisionview.py	2007-12-06 23:49:08 +0000
+++ revisionview.py	2008-01-21 17:32:13 +0000
@@ -77,10 +77,7 @@
         self._revision = None
         self._branch = branch
 
-        if self._branch is not None and self._branch.supports_tags():
-            self._tagdict = self._branch.tags.get_reverse_tag_dict()
-        else:
-            self._tagdict = {}
+        self.update_tags()
 
         self.set_file_id(None)
 
@@ -179,6 +176,14 @@
         else:
             self.file_info_box.hide()
 
+    def update_tags(self):
+        if self._branch is not None and self._branch.supports_tags():
+            self._tagdict = self._branch.tags.get_reverse_tag_dict()
+        else:
+            self._tagdict = {}
+
+        self._add_tags()
+
     def set_children(self, children):
         self._add_parents_or_children(children,
                                       self.children_widgets,
@@ -192,6 +197,8 @@
         """Callback for when the go button for a parent is clicked."""
 
     def _add_tags(self, *args):
+        if self._revision is None: return
+
         if self._tagdict.has_key(self._revision.revision_id):
             tags = self._tagdict[self._revision.revision_id]
         else:

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-01-21 17:23:10 +0000
+++ viz/branchwin.py	2008-01-21 17:32:13 +0000
@@ -297,6 +297,7 @@
         self.revisionview.show()
         self.revisionview.set_show_callback(self._show_clicked_cb)
         self.revisionview.connect('notify::revision', self._go_clicked_cb)
+        self.treeview.connect('tag-added', lambda w, t, r: self.revisionview.update_tags())
         return self.revisionview
 
     def _tag_selected_cb(self, menuitem, revid):

